#include "Background.h"

Background::Background(){
	img = "Image/stars1.png";
}

Background::~Background(){
}

void Background::Init(){
	Unsolid::Init();
	speed = 20;
	
}

bool Background::Update(float pdt){
	Unsolid::Update(pdt);

	vel.x = -speed;
	if(pos.x <= -image->w())
		pos.x = 0;

	return false;
}

void Background::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);
	image->draw(Vector2(pos.x + image->w(), pos.y), screen);
}

void Background::setSpeed(float SPEED){
	speed = SPEED;
}

float Background::getSpeed(){
	return speed;
}