#ifndef DEADHANDLER_H
#define DEADHANDLER_H

#include "SDL.h"
#include <typeinfo>
#include "GameManager.h"
#include "Timer2.h"
#include "TheBoss.h"
#include "GunArm.h"
#include "SwarmChildren.h"
#include "SwarmMother.h"
#include "Ship.h"

class DeadHandler{
public:
	DeadHandler();
	~DeadHandler();
	void handler(Entity* k);
	void setShipPos(Vector2 pos);
	bool deadBoss(Entity* k);
	void deadSwarm(Entity* k);
	bool deadShip(Entity* k);
private:
	GameManager *game;

	bool swarmHunt, gunArmDead;;
	Timer2 timeSwarm;
	Vector2 swarmHuntMother;
	Vector2 spos;
};

#endif