#include "Enemy.h"


Enemy::Enemy(){
}


Enemy::~Enemy(){
}

void Enemy::Init(){
	Solid::Init();
	speed = 1;
	health = 1;
}

bool Enemy::Update(float pdt){
	Solid::Update(pdt);
	if(worldEdge())
		dead = true;

	if(health <= 0)
		dead = true;

	return false;
}

void Enemy::Draw(SDL_Surface* screen){
	Solid::Draw(screen);
}

bool Enemy::worldEdge(){
	if((pos.x < -size) || (pos.x > SCREEN_WIDTH*2) || (pos.y < -size) || (pos.y > SCREEN_HEIGTH + size))
		return true;
	return false;
}

void Enemy::setHealth(int Health){
	health = Health;
}

int Enemy::getHealth(){
	return health;
}

void Enemy::setDamage(int damage){
	health -= damage;
}

Vector2 Enemy::getPos(){
	return pos;
}
