#ifndef EVEHANDLER_H
#define EVEHANDLER_H

#include "SDL.h"
#include <vector>
#include "Vector2.h"
#include "Timer2.h"

class EveHandler{
public:
	EveHandler();
	virtual ~EveHandler();

	void AddEvent(SDL_Event* even);

	bool EventTypeExists(SDL_EventType type);

	bool KeyHit(SDLKey Key);
	bool KeyDown(SDLKey Key);
	bool KeyUp(SDLKey Key);
	bool mouseButtonHit(int button);
	void setMousePos(int x, int y);
	Vector2 getMousePos();
private:
	bool RemoveKey(SDLKey Key);
	bool RemoveKey(int index);
	bool RemoveMouseButton();
	Vector2 mousePos;
	Timer2 timeButton;

	std::vector<SDL_Event*> eve;
};

#endif