#include "RedBullet.h"


RedBullet::RedBullet(Vector2 Pos, int Speed){
	pos = Pos;
	diagonal = false;
	if(Speed < 200)
		speed = 200;
	else
		speed = Speed;
	img = "Image/RedBullet.png";
}

RedBullet::RedBullet(Vector2 Pos, int Speed, int way){
	pos = Pos;
	diagonal = true;
	if(Speed < 200)
		speed = 200;
	else
		speed = Speed;

	moveWay = way;
	img = "Image/RedBullet.png";
}

RedBullet::~RedBullet(){

}

void RedBullet::Init(){
	Weapon::Init();
	size = 16;
	pos.y -= (size / 2);
	damage = 2;
	
}

bool RedBullet::Update(float pdt){
	Weapon::Update(pdt);
	move(pdt);
	return false;
}

void RedBullet::Draw(SDL_Surface* screen){
	Weapon::Draw(screen);
}

void RedBullet::move(float dt){
	vel.x = speed;
	if(diagonal){
		if(moveWay == 1)
			vel.y = speed / 3;
		if(moveWay == 2){
			vel.y = speed;
			vel.x = 0;
		}
		if(moveWay == -1)
			vel.y = -speed / 3;
		if(moveWay == -2){
			vel.y = -speed;
			vel.x = 0;
		}
	}
}

