#ifndef SHIP_H
#define SHIP_H

#include "Solid.h"
#include "Timer2.h"
#include "RedBullet.h"
#include "GreenBullet.h"

class Ship : public Solid{
public:
	Ship();
	~Ship();

	void Init(); 
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);

	void rapidBullet();
	void upgradeGun();
	Vector2 getPos();
	void setWon(bool win);
private:
	int weapon;
	int huzzelInterval;
	Uint8* keystates;
	float speed;
	int bulletSpeed;
	bool win;

	Timer2 time, timerBullet, timerRocket;
	GameManager *game;

	void move();
	void worldEdge();
	void animRight();
	void stopRight();
	void soundMap();
	void weaponSortiment();
};

#endif