#include "SpaceRockBig.h"


SpaceRockBig::SpaceRockBig(){
	img = "Image/BigRock.png";
}

SpaceRockBig::SpaceRockBig(Vector2 Pos){
	pos = Pos;
	img = "Image/BigRock.png";
}

SpaceRockBig::~SpaceRockBig(){
}


void SpaceRockBig::Init(){
	Enemy::Init();
	speed = 150;
	health = 50;
	size = 96;
}

bool SpaceRockBig::Update(float pdt){
	Enemy::Update(pdt);
	move();
	ifDead();
	return false;
}

void SpaceRockBig::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
}

void SpaceRockBig::move(){
	vel.x = -speed;
}

int SpaceRockBig::getHealth(){
	return health;
}

void SpaceRockBig::ifDead(){
	if(dead){
		for(int i = 0; i < (1 +rand()% 2); i++){
			game->addEntity(new SpaceRockSmall(Vector2(pos.x + rand()% size, pos.y + rand()% size)), "Stage1");
		}
	}
}