#include "SpawnHandler.h"


SpawnHandler::SpawnHandler(){
	name = "temp";
	game = &GameManager::getSingleton();
	timeSpawn.start();
	timeFooSpawn.start();
	timeFooSpawn2.start();
	timeSmallRock.start();
	timeMedRock.start();
	timeBigRock.start();
	countFoo = 0;
	IntervalFoo = 3500;
}

SpawnHandler::~SpawnHandler(){
}

void SpawnHandler::setName(std::string Name){
	name = Name;
}

void SpawnHandler::spawn(float dt){
	gamePaused(dt);
	if((timeSpawn.get_ticks() > 2000) && (timeSpawn.get_ticks() < 18000)){
		if(timeFooSpawn.get_ticks() > 500 + (rand() % 1500)){
			timeFooSpawn.start();
			GameManager::getSingleton().addEntity(new TheFoo(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)), 0), name);
		}
	}
	if((timeSpawn.get_ticks() > 20000) && (timeSpawn.get_ticks() < 20000 + IntervalFoo - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 4), 1, 1);
	
	if((timeSpawn.get_ticks() > 20000 + IntervalFoo) && (timeSpawn.get_ticks() < 20000 + IntervalFoo*2 - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2), 1, 1);
	
	if((timeSpawn.get_ticks() > 20000 + IntervalFoo*2) && (timeSpawn.get_ticks() < 20000 + IntervalFoo*3 - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH - (SCREEN_HEIGTH / 4)), 1, 1);
	
	if((timeSpawn.get_ticks() > 20000 + IntervalFoo*3) && (timeSpawn.get_ticks() < 20000 + IntervalFoo*4 - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2), 2, 1);
	
	if((timeSpawn.get_ticks() > 20000 + IntervalFoo*4) && (timeSpawn.get_ticks() < 20000 + IntervalFoo*5 - 1000)){
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 4), 2, 1);
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH - (SCREEN_HEIGTH / 4)), 2, 2);
	}
	if((timeSpawn.get_ticks() > 20000 + IntervalFoo*5) && (timeSpawn.get_ticks() < 20000 + IntervalFoo*6))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2), 3, 1);

	if((timeSpawn.get_ticks() > 43000) && (timeSpawn.get_ticks() < 65000)){
		if(timeFooSpawn.get_ticks() > 500 + (rand() % 1500)){
			timeFooSpawn.start();
			GameManager::getSingleton().addEntity(new TheFoo(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)), 1), name);
		}
	}

	if((timeSpawn.get_ticks() > 65000) && (timeSpawn.get_ticks() < 80000)){
		if(timeFooSpawn.get_ticks() > 500 + (rand() % 1500)){
			timeFooSpawn.start();
			GameManager::getSingleton().addEntity(new TheFoo(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)), 2), name);
		}
	}

	if((timeSpawn.get_ticks() > 75000) && (timeSpawn.get_ticks() < 120000)){
		smallRock(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)));
	}
	if((timeSpawn.get_ticks() > 80000) && (timeSpawn.get_ticks() < 115000)){
		medRock(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)));
	}
	if((timeSpawn.get_ticks() > 85000) && (timeSpawn.get_ticks() < 110000)){
		bigRock(Vector2(SCREEN_WIDTH + 20, 55  + rand() % (SCREEN_HEIGTH - 110)));
	}
	if((timeSpawn.get_ticks() > 123000) && (timeSpawn.get_ticks() < 123500)){
		if(timeFooSpawn.get_ticks() > 1000){
			timeFooSpawn.start();
			game->addEntity(new SwarmMother(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2)), name);
		}
	}
	
	if((timeSpawn.get_ticks() > 130000) && (timeSpawn.get_ticks() < 130000 + IntervalFoo - 1000)){
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 4), 2, 1);
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH - (SCREEN_HEIGTH / 4)), 2, 2);
	}

	if((timeSpawn.get_ticks() > 130000 + IntervalFoo) && (timeSpawn.get_ticks() < 130000 + IntervalFoo*2 - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2), 1, 1);

	if((timeSpawn.get_ticks() > 130000+ IntervalFoo*2) && (timeSpawn.get_ticks() < 130000 + IntervalFoo*3 - 1000)){
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 4), 2, 1);
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH - (SCREEN_HEIGTH / 4)), 2, 2);
	}

	if((timeSpawn.get_ticks() > 130000 + IntervalFoo*3) && (timeSpawn.get_ticks() < 130000 + IntervalFoo*4 - 1000))
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2), 1, 1);

	if((timeSpawn.get_ticks() > 130000 + IntervalFoo*4) && (timeSpawn.get_ticks() < 130000 + IntervalFoo*5 - 1000)){
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 4), 2, 1);
		foos(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH - (SCREEN_HEIGTH / 4)), 2, 2);
	}
	if((timeSpawn.get_ticks() > 150000) && (timeSpawn.get_ticks() < 150500)){
		if(timeFooSpawn.get_ticks() > 1000){
			timeFooSpawn.start();
			game->addEntity(new SwarmMother(Vector2(SCREEN_WIDTH, SCREEN_HEIGTH / 2)), name);
		}
	}

	if((timeSpawn.get_ticks() > 160000) && (timeSpawn.get_ticks() < 160500)){
		if(timeFooSpawn.get_ticks() > 1000){
			timeFooSpawn.start();
			game->addEntity(new GunArm(Vector2(SCREEN_WIDTH, 80)), name);
			game->addEntity(new TheBoss(Vector2(SCREEN_WIDTH, 150)), name);
			game->addEntity(new GunArm(Vector2(SCREEN_WIDTH, 300)), name);	
		}
	}
}

void SpawnHandler::foos(Vector2 pos, int move, int set){
	if((timeFooSpawn.get_ticks() > 500) && (set == 1)){
		GameManager::getSingleton().addEntity(new TheFoo(pos, move), name);
		timeFooSpawn.start();
	}
	else if((timeFooSpawn2.get_ticks() > 500) && (set == 2)){
		GameManager::getSingleton().addEntity(new TheFoo(pos, move), name);
		timeFooSpawn2.start();
	}
}

void SpawnHandler::smallRock(Vector2 pos){
	if(timeSmallRock.get_ticks() > 1000){
		game->addEntity(new SpaceRockSmall(pos), name);
		timeSmallRock.start();
	}
}

void SpawnHandler::medRock(Vector2 pos){
	if(timeMedRock.get_ticks() > 3000){
		game->addEntity(new SpaceRockMedium(pos), name);
		timeMedRock.start();
	}
}

void SpawnHandler::bigRock(Vector2 pos){
	if(timeBigRock.get_ticks() > 5000){
		game->addEntity(new SpaceRockBig(pos), name);
		timeBigRock.start();
	}
}

void SpawnHandler::gamePaused(float dt){
	if(dt == 0){
		timeSpawn.pause();
		timeFooSpawn.pause();	
		timeFooSpawn2.pause();	
		timeSmallRock.pause();	
		timeMedRock.pause();	
		timeBigRock.pause();		
	}
	else{
		timeSpawn.unpause();
		timeFooSpawn.unpause();	
		timeFooSpawn2.unpause();	
		timeSmallRock.unpause();	
		timeMedRock.unpause();	
		timeBigRock.unpause();	
	}
}