#ifndef SPAWNHANDLER_H
#define SPAWNHANDLER_H

#include "SDL.h"
#include "GameManager.h"
#include "Timer2.h"
#include "TheFoo.h"
#include "SpaceRockSmall.h"
#include "SpaceRockMedium.h"
#include "SpaceRockBig.h"
#include "SwarmChildren.h"
#include "SwarmMother.h"
#include "TheBoss.h"
#include "GunArm.h"

class SpawnHandler{
public:
	SpawnHandler();
	~SpawnHandler();

	void setName(std::string Name);
	void spawn(float dt);
	

private:
	GameManager* game;
	std::string name;
	int countFoo, IntervalFoo;
	float dt;
	Timer2 timeSpawn, timeFooSpawn, timeFooSpawn2, timeSmallRock, timeMedRock, timeBigRock;

	void foos(Vector2 pos, int move, int set);
	void smallRock(Vector2 pos);
	void medRock(Vector2 pos);
	void bigRock(Vector2 pos);
	void gamePaused(float dt);
};

#endif