#ifndef STAGE1_H
#define STAGE1_H

#include "GameScreen.h"
#include <typeinfo>
#include "SDL.h"
#include "SDL_mixer.h"
#include "GameManager.h"
#include "Background.h"
#include "BackgroundLayer2.h"
#include "BackgroundPlanet.h"
#include "Ship.h"
#include "Timer2.h"
#include "UI.h"
#include "GameloopHandler.h"
#include "SpawnHandler.h"
#include "TheBoss.h"
#include "GunArm.h"
#include "DeadHandler.h"
#include "LoadingScreen.h"
#include "MainScreen.h"

class Stage1 : public GameScreen{
public:
	Stage1();
	~Stage1();

	void Init(std::string pName); 
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);
	std::string getName();
	void addEntity(Entity* entity);
	void delEntity(Entity* entity);
	

private:
	bool shipDead, won;
	SDL_Surface* screen;
	GameManager *game;
	Mix_Music *music;
	GameloopHandler glh;
	SpawnHandler sh;
	DeadHandler dh;

	void pushLast();
};

#endif