#ifndef THEBOSS_H
#define THEBOSS_H

#include "Enemy.h"
#include "Timer2.h"
#include <cmath>

class TheBoss : public Enemy{
public:
	TheBoss();
	TheBoss(Vector2 Pos);
	~TheBoss();

	void Init();
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);
	void move();
	int getHealth();
	void chargingMaLasor(SDL_Surface* screen);
	void deathray(SDL_Surface* screen);
	bool deathrayActive();
	bool isDead();
private:
	bool deathrayAct;
	Timer2 timeCharge, timeChargeBlink, timeRay, timeFlash, timeX;
	Image *charge, *ray;
};

#endif