#include "TheFoo.h"

TheFoo::TheFoo(){
	img = "Image/smallmine.png";
}

TheFoo::TheFoo(Vector2 Pos, int moveType){
	pos = Pos;
	moveCase = moveType;
	img = "Image/smallmine.png";
}

TheFoo::~TheFoo(){
}

void TheFoo::Init(){
	Enemy::Init();
	speed = 300;
	health = 10;
	size = 64;
	timeX.start();
	
}

bool TheFoo::Update(float pdt){
	Enemy::Update(pdt);
	move();
	if(pdt == 0)
		timeX.pause();
	else
		timeX.unpause();
	return false;
}

void TheFoo::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
}

void TheFoo::move(){
	vel.x = -speed;
	switch(moveCase){
	case 1:
		vel.y = cosf(timeX.get_ticks()*0.005f) * 100;
		break;
	case 2:
		vel.y = cosf(timeX.get_ticks()*0.005f) * 200;
		break;
	case 3:
		vel.y = cosf(timeX.get_ticks()*0.005f) * SCREEN_HEIGTH;
		break;
	default:
		break;
	}
}


int TheFoo::getHealth(){

	return health;
}
