#include "BackgroundPlanet.h"

BackgroundPlanet::BackgroundPlanet(){
	img = "Image/planet.png";
}

BackgroundPlanet::~BackgroundPlanet(){
}

void BackgroundPlanet::Init(){
	Unsolid::Init();
	speed = 30;
	
	pos.x = 500;
	pos.y = 50;
	time.start();
}

bool BackgroundPlanet::Update(float pdt){
	Unsolid::Update(pdt);

	vel.x = -speed;
	if(pos.x <= -image->w()){
		pos.x = 2000;
		pos.y =  -400 +rand()%800;
	}
	return false;
}

void BackgroundPlanet::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);
}

void BackgroundPlanet::setSpeed(float SPEED){
	speed = SPEED;
}

float BackgroundPlanet::getSpeed(){
	return speed;
}