#include "BulletEnemy.h"

BulletEnemy::BulletEnemy(Vector2 Pos){
	pos = Pos;
	img = "Image/GreenBullet.png";
}

BulletEnemy::~BulletEnemy(){
	pos = 0;
}

void BulletEnemy::Init(){
	Weapon::Init();
	size = 16;
	pos.y -= (size / 2);
	damage = 10;
	speed = 400;
	
}

bool BulletEnemy::Update(float pdt){
	Weapon::Update(pdt);
	move(pdt);
	return false;
}

void BulletEnemy::Draw(SDL_Surface* screen){
	Weapon::Draw(screen);
}

void BulletEnemy::move(float dt){
	vel.x = -speed;
}
