#include "DeadHandler.h"


DeadHandler::DeadHandler(){
	game = &GameManager::getSingleton();
	spos = Vector2(0,0);

	swarmHunt = false;
	gunArmDead = false;
}

DeadHandler::~DeadHandler(){
}

void DeadHandler::handler(Entity* k){
	deadBoss(k);
	deadSwarm(k);
}

void DeadHandler::setShipPos(Vector2 pos){
	spos = pos;
}

bool DeadHandler::deadBoss(Entity* k){
	if((typeid(*k) == typeid(TheBoss))){
		if(((TheBoss*)k)->isDead()){
			gunArmDead = true;
		}
	}
	if((typeid(*k) == typeid(GunArm))){
		if((typeid(*k) == typeid(GunArm)) && (gunArmDead)){
			((GunArm*)k)->dead = true;
			return true;
		}
	}
	return false;
}

void DeadHandler::deadSwarm(Entity* k){
	if((typeid(*k) == typeid(SwarmMother))){
		if(((SwarmMother*)k)->getDead()){
			swarmHunt = true;
			timeSwarm.start();
		}
		else
			swarmHuntMother = ((SwarmMother*)k)->getPos();
	}
	if(timeSwarm.get_ticks() > 6000){
		swarmHunt = false;
		timeSwarm.start();
		timeSwarm.pause();
		swarmHuntMother = Vector2(-100, SCREEN_HEIGTH/2);
	}

	if((typeid(*k) == typeid(SwarmChildren)) && (swarmHunt))
    	((SwarmChildren*)k)->hunt(spos);
	else if(typeid(*k) == typeid(SwarmChildren))
		((SwarmChildren*)k)->hunt(swarmHuntMother);
}

bool DeadHandler::deadShip(Entity* k){
	if((typeid(*k) == typeid(Ship))){
		if(((Ship*)k)->dead){
			return true;
		}
	}
	return false;
}
