#include "FileManager.h"


FileManager::FileManager(){
}


FileManager::~FileManager(){
}

void FileManager::load(std::string filename){
	if(files.find(filename) != files.end())
		return;

	Image* img = new Image(filename.c_str());
	files.insert(std::pair<std::string, Image*>(filename, img));
}

Image* FileManager::get(std::string filename){
	if(files.find(filename) != files.end())
		return files[filename];

	load(filename);
	return files[filename];
}