#include "GreenBullet.h"

GreenBullet::GreenBullet(Vector2 Pos, int Speed){
	pos = Pos;
	diagonal = false;
	if(Speed < 200)
		speed = 200;
	else
		speed = Speed;
	img = "Image/GreenBullet.png";
}

GreenBullet::GreenBullet(Vector2 Pos, int Speed, int way){
	pos = Pos;
	diagonal = true;
	if(Speed < 200)
		speed = 200;
	else
		speed = Speed;
	moveWay = way;
	img = "Image/GreenBullet.png";
}

GreenBullet::~GreenBullet(){
}

void GreenBullet::Init(){
	Weapon::Init();
	size = 16;
	pos.y -= (size / 2);
	damage = 4;
	
}

bool GreenBullet::Update(float pdt){
	Weapon::Update(pdt);
	move(pdt);
	return false;
}

void GreenBullet::Draw(SDL_Surface* screen){
	Weapon::Draw(screen);
}

void GreenBullet::move(float dt){
	vel.x = speed;
	if(diagonal){
		if(moveWay == 1)
			vel.y = speed / 3;
		if(moveWay == 2){
			vel.y = speed;
			vel.x = 0;
		}
		if(moveWay == -1)
			vel.y = -speed / 3;
		if(moveWay == -2){
			vel.y = -speed;
			vel.x = 0;
		}
	}
}
