#include "Money.h"


Money::Money(){
}

Money::~Money(){
}

void Money::Init(){
	Solid::Init();
	worth = 0;
	speed = 20;
}

bool Money::Update(float pdt){
	Solid::Update(pdt);
	move(pdt);
	if(worldEdge())
		dead = true;

	return false;
}

void Money::Draw(SDL_Surface* screen){
	Solid::Draw(screen);
}

void Money::move(float dt){
	pos.x -= speed * dt;
}

bool Money::worldEdge(){
	if((pos.x < -size) || (pos.x > SCREEN_WIDTH + size) || (pos.y < -size) || (pos.y > SCREEN_HEIGTH + size))
		return true;
	return false;
}

int Money::getWorth(){
	return worth;
}

Vector2 Money::getPos(){
	return pos;
}

void Money::hunt(Vector2 hunted){
	huntVel = (hunted - pos).Normalize();
	pos += huntVel;
}

