#include "SmallExplosion.h"


SmallExplosion::SmallExplosion(){
	img = "Image/SmallExplosion.png";
}

SmallExplosion::SmallExplosion(Vector2 Pos){
	pos = Pos;
	img = "Image/SmallExplosion.png";
}

SmallExplosion::~SmallExplosion(){
}


void SmallExplosion::Init(){
	Unsolid::Init();
	anim = true;
	image->addAnim(0, 0, 21, 21, 7);
	timeExpAnim.start();
	frame = 0;
}

bool SmallExplosion::Update(float pdt){
	Unsolid::Update(pdt);
	explosionSpeed();
	return false;
}

void SmallExplosion::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);

}

void SmallExplosion::explosionSpeed(){
	if(timeExpAnim.get_ticks() > 100){
		frame++;
		timeExpAnim.start();
	}
	if(frame >= 7)
		dead = true;
}