#include "Solid.h"


Solid::Solid(){
	initiated = false;
	game = &GameManager::getSingleton();
}

Solid::~Solid(){
}

void Solid::Init(){
	initiated = true;
	anim = false;
	dead = false;
	frame = 0;
	
	image = game->file.get(img);
}

bool Solid::Update(float pdt){
	if(initiated){
		pos += vel * pdt;
	}
	return false;
}

void Solid::Draw(SDL_Surface* screen){
	if(initiated){
		if(anim)
			image->drawAnim(pos, screen, frame);
		else
			image->draw(pos, screen);
	}
	SDL_FreeSurface(screen);
}