#include "SwarmChildren.h"

SwarmChildren::SwarmChildren(){
	img = "Image/SmallBug.png";
}

SwarmChildren::SwarmChildren(Vector2 Pos){
	pos = Pos;
	img = "Image/SmallBug.png";
}

SwarmChildren::~SwarmChildren(){
}

void SwarmChildren::Init(){
	Enemy::Init();
	speed = 100;
	health = 10;
	size = 20;
	timeX.start();
}

bool SwarmChildren::Update(float pdt){
	Enemy::Update(pdt);
	move();
	if(pdt == 0)
		timeX.pause();
	else
		timeX.unpause();
	return false;
}

void SwarmChildren::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
}

void SwarmChildren::move(){
	vel.y = sinf(timeX.get_ticks()*0.008f) * 100;
	pos.x -= 0.10;
}

int SwarmChildren::getHealth(){
	return health;
}

void SwarmChildren::hunt(Vector2 hunted){
	huntVel = (hunted - pos).Normalize();
	pos.x += huntVel.x * 0.04;
	pos.y += huntVel.y * 0.05;
}