#ifndef SWARMMOTHER_H
#define SWARMMOTHER_H

#include "Enemy.h"
#include "SwarmChildren.h"
#include "Timer2.h"
#include <cmath>

class SwarmMother : public Enemy{
public:
	SwarmMother();
	SwarmMother(Vector2 Pos);
	~SwarmMother();

	void Init(); 
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);
	void move();
	int getHealth();
	bool getDead();

private:
	GameManager* game;

	void spawnChildren();
	Timer2 timeX;
};

#endif