#include "Timer2.h"

Timer2::Timer2(){
	startTicks = 0;
	pausedTicks = 0;
	paused = false;
	started = false;
}

void Timer2::start(){
	started = true;
	paused = false;
	startTicks = SDL_GetTicks();
}

void Timer2::stop(){
	started = false;
	paused = false;
}

int Timer2::get_ticks(){
	if(started == true){
		if(paused == true){
			return pausedTicks;
		}
		else{
			return SDL_GetTicks() - startTicks;
		}
	}
	return 0;
}

void Timer2::pause(){
	if((started == true) && (paused == false)){
		paused = true;
		pausedTicks = SDL_GetTicks() - startTicks;
	}
}

void Timer2::unpause(){
	if(paused == true){
		paused = false;
		startTicks = SDL_GetTicks() - pausedTicks;
		pausedTicks = 0;
	}
}

bool Timer2::is_started(){
	return started;
}

bool Timer2::is_paused(){
	return paused;
}
