#include "Unsolid.h"

Unsolid::Unsolid(){
	initiated = false;
	game = &GameManager::getSingleton();
}

Unsolid::~Unsolid(){
}

void Unsolid::Init(){
	initiated = true;
	anim = false;
	dead = false;
	frame = 0;
	speed = 0;
	
	image = game->file.get(img);
}

bool Unsolid::Update(float pdt){
	if(initiated){
		pos += vel * pdt;
	}
	return false;
}

void Unsolid::Draw(SDL_Surface* screen){
	if(initiated){
		if(anim)
			image->drawAnim(pos, screen, frame);
		else
			image->draw(pos, screen);
	}
	SDL_FreeSurface(screen);
}